

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <locale.h>

int
main (int argc, char *argv[])
{
	setlocale (LC_ALL, "");
	char outstr[200];
	char *format;
	format="%a %b %e %X %Z %Y";

	time_t t;
	t = time(NULL);

	struct tm *tmp;
	tmp = localtime(&t);

	if (tmp == NULL)
	{
		perror("localtime");
		exit(EXIT_FAILURE);	
	}


	int opt;
	int bydefault;

	bydefault = 1;
	opterr = 0;

	while ((opt = getopt(argc,argv,"Rurfd")) != -1 )
	{
		switch(opt)
		{

		case 'R':
			bydefault = 0;
			format = "%a, %d %b %X %Y %z";
			break;

		case 'u':
			bydefault = 0;
			tmp = gmtime(&t);
			
			if (tmp == NULL)
			{
				perror("gmtime");
				exit(EXIT_FAILURE);
			}
			format = "%a %b %e %X %Z %Y";
			break;
			
		case 'r':
			bydefault = 0;
			struct stat pmt;	

			if (argc == 2) 
			{
				fprintf(stderr,"date2: ключ должен использоваться с аргументом -%s \n", argv[1]);
				exit(EXIT_FAILURE);
			} else {
				stat(argv[2], &pmt);
				tmp = localtime(&pmt.st_ctime);
				format = "%a %b %e %X %Z %Y";

				++optind;
				if (argc > 3)
					if (*argv[optind] == '+')
						format = argv[optind];
			}

			break;

		case 'f':
			bydefault = 0;

			if (argc == 2) 
			{
				fprintf(stderr,"date2: ключ должен использоваться с аргументом -%s \n", argv[1]);
				exit(EXIT_FAILURE);
			} else {

				char line[255];
				int buflen;
				FILE *fp;

				if ((fp = fopen(argv[2],"rt")) == NULL) {
					fprintf(stderr, "Не могу открыть файл \n");
					exit(EXIT_FAILURE);
				}

				buflen = 1;

				while (fgets(line, buflen, fp) != NULL) {
					printf("%s",line);
					buflen = buflen + 1;
				}
	
				exit(EXIT_FAILURE);
			}
			
			break;

		case 'd':
			bydefault = 0;

			if (argc == 2) 
			{
				fprintf(stderr,"date2: ключ должен использоваться с аргументом -%s \n", argv[1]);
				exit(EXIT_FAILURE);
			} else {
				
			}

			break;


		default:
			fprintf(stderr,"date2: неверный ключ -%s \n", argv[1]);
			exit(EXIT_FAILURE);
			break;	
		}
	}

	if (bydefault == 1)
		if (argc > 1 && *argv[optind] == '+')
			format = argv[optind];

	strftime(outstr, sizeof(outstr), format, tmp);
	printf("%s\n",outstr);
	
	exit(EXIT_SUCCESS);
}


